from plistlib import readPlist

FILE_NAME = 'cnf_objects_pos.plist'

def getDefineStringFromKey(key, id):
    return '#define ID_POS_' + str.upper(key) + ' ' + str(id) + '\n'
	
def generateConfigForObject(objFile):
    pl = readPlist(objFile)
    index = 0

    obj_key_id = '#define PATH_CONF_OBJ_POS "' + objFile + '"\n'
    obj_key_id += 'extern const char* OBJ_POS[];\n'
    obj_key_name = 'const char* OBJ_POS[] = { \n'
    for key in pl:
        obj_key_id += getDefineStringFromKey(key, index)
        obj_key_name += '\t"' + key + '"' + ',\n'
        index += 1

    obj_key_name = obj_key_name[:-2]
    obj_key_name += '\n};\n'
    obj_key_id += '#define TOTAL_OBJ ' + str(index) + '\n'

    obj_key_name += '\n\n';
    obj_key_id += '\n\n';
    return obj_key_id, obj_key_name
	
res_h = '#ifndef __CONFIG_H__\n#define __CONFIG_H__\n\n'
res_cpp = '#include "Config.h"\n\n'

t = generateConfigForObject(FILE_NAME)
res_h += t[0]
res_cpp += t[1]

res_h += '#endif\t//__CONFIG_H__'

#Write output to file
f = open('Config.h', 'w')
f.write(res_h);
f.close()

f = open('Config.cpp', 'w')
f.write(res_cpp)
f.close()